create function reperes_proches(float, point, point) returns setof integer as '
select id from reperes 
where (position <-> $2) <  ($2 <-> $3) and
      (position <-> $3) <  ($2 <-> $3) and
	  ((position <-> $2) + (position <-> $3)) < $1 * ( $2 <-> $3)
order by (position <-> $2)' language 'SQL';
create function aerodromes_proches(float, point, point) returns setof integer as '
select id from aerodromes 
where (position <-> $2) <  ($2 <-> $3) and
      (position <-> $3) <  ($2 <-> $3) and
	  ((position <-> $2) + (position <-> $3)) < $1 * ( $2 <-> $3)
order by (position <-> $2)' language 'SQL';

create function est_connecte(VARCHAR) returns boolean as '
declare
  session record;
begin
    select into session * from sessions where session_id = $1 ;
    if not found then
	return false;
    end if;
    if (now() - session.passage) > \'5min\' then
	return false;
    end if;
    update sessions set passage = now() where session_id = $1 ;
    return true;
end;
' language 'plpgsql';

drop function connecte(varchar, varchar, varchar);
create function connecte(varchar, varchar, varchar) returns boolean as '
declare
   p integer;
   r record;
begin
   select into p id from pilotes where email = $2 and mot_de_passe = $3; 
   raise notice \'id=%\' , p;
   if found then
     delete from sessions where session_id = $1;
     for r in select session_id from sessions where pilote = p loop
         update sessions set session_id=$1, passage = now() where pilote = p; 
         return true;
     end loop;
     insert into sessions values ( $1 , now(), p);
     return true;
   end if;
   return false;
end;
' language 'plpgsql';

drop function inscrit(varchar, varchar, point, varchar, varchar , boolean, bytea, varchar);
create function inscrit(varchar, varchar, point, varchar, varchar, boolean, bytea, varchar) returns integer as '
declare
    pilote integer;
begin
    select into pilote id from pilotes where email = $4;
    if found then
	return -1;
    end if;
    insert into pilotes(nom,position,email,mot_de_passe, publie,photo, photo_type) values ( $2, $3, $4, $5, $6, $7, $8);
    if connecte($1, $4, $5) then
	return 1;
    end if;
    return 0;
end;
' language 'plpgsql';
